/*
Copyright 2022, Savanni D'Gerinel <savanni@luminescent-dreams.com>

This file is part of Savanni's AVR library.

This AVR library is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This AVR library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this AVR library. If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef __I2C_H__
#define __I2C_H__

#include <base.h>

typedef enum {
    ok,
    nak
} i2c_error_e;

typedef struct {
    dio_t sda;
    dio_t clk;
} i2c_host_t;

typedef struct {
    dio_t sda;
    dio_t clk;
    uint8_t addr;
}

void i2c_init_host(i2c_host_t *, i2c_error_e *);
void i2c_init_client(i2c_client_t *, i2c_error_e *); 

void i2c_host_write(i2c_host_t *, uint8_t, uint8_t, size_t, i2c_error_e);

#endif
